<script lang="ts" setup name="ListApproval">
import type { PropType, Ref } from 'vue'
import { getCurrentInstance, ref } from 'vue'
import { ElLoading, ElMessage, ElMessageBox } from 'element-plus'
import type { IButton, IOptions, ISupplier, IlistApprovalQuery, IlistType } from '../plan_interface'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { printJSON } from '@/utils/printUtils'
import { getApprovalDelete, getDeptTree, getListSubmit, getapprovalList } from '@/api/system/plan'
import ApprovalDialog from '@/components/Approval/ApprovalDialog.vue'
import { SCHEDULE } from '@/utils/scheduleDict'
import { submitApproval } from '@/api/approval'
const props = defineProps({
  status: {
    type: String,
    default: '0',
  },
  buttons: {
    type: Array as PropType<IButton[]>,
    default: () => [],
  },
})
const emit = defineEmits(['setData']) // 关闭
// 获取权限
const { proxy } = getCurrentInstance() as any
// 操作列宽度-计算属性
const operationWidth = computed(() => {
  return props.buttons.length * 40 + 24
})

// 查询条件
const listQuery: Ref<IlistApprovalQuery> = ref({
  approvalStatus: props.status,
  formId: SCHEDULE.TRAIN_APPROVAL,
  createTime: '',
  deptId: '',
  director: '',
  effectiveCompany: '',
  trainTime: '',
  offset: 1,
  limit: 20,
})
// 表格数据
const list = ref<ISupplier[]>([])
// 总数
const total = ref(0)
// 控制审批操作弹窗的开关
const applyShow = ref(false)
// 表头
const columns = ref<TableColumn[]>([
  {
    text: '计划编号',
    value: 'planNo',
    width: '90',
    align: 'center',
  },
  {
    text: '培训名称',
    value: 'planName',
    width: '90',
    align: 'center',
  },
  {
    text: '培训对象',
    value: 'trainPerson',
    width: '90',
    align: 'center',
  },
  {
    text: '培训人数',
    value: 'trainNumber',
    width: '90',
    align: 'center',
  },
  {
    text: '培训学时',
    value: 'trainHour',
    width: '90',
    align: 'center',
  },
  {
    text: '培训时间',
    value: 'trainTime',
    width: '90',
    align: 'center',
  },
  {
    text: '主管部门',
    value: 'deptName',
    width: '90',
    align: 'center',
  },
  {
    text: '实施单位',
    value: 'effectiveCompany',
    width: '90',
    align: 'center',
  },
  {
    text: '负责人',
    value: 'director',
    align: 'center',
  },
  {
    text: '培训内容',
    value: 'trainContent',
    width: '90',
    align: 'center',
  },
  {
    text: '创建时间',
    value: 'createTime',
    width: '90',
    align: 'center',
  },
  {
    text: '审批状态',
    value: 'approvalStatusName',
    width: '90',
    align: 'center',
  },
])
// 初始化路由
const $router = useRouter()
const buttonArray = ref<string[]>([])
// 选中的内容
const checkoutList = ref<string[]>([])
// 文件上传input
const fileRef = ref()
// 删除id
const deleteId = ref('')
// 详情id
const infoId = ref('0')
// 点击按钮
const buttonType = ref('')
const loadingTable = ref(false)
const fetchData = (isNowPage: boolean) => {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.value.offset = 1
  }
  getapprovalList(listQuery.value).then((response) => {
    list.value = response.data.rows
    total.value = parseInt(response.data.total)
    loadingTable.value = false
  }).catch((_) => {
    loadingTable.value = false
  })
}
// fetchData(true)
// 多选发生改变时
const handleSelectionChange = (e: any) => {
  checkoutList.value = e.map((item: { id: string }) => item.id)
}
// 点击删除和编辑的参数类型
interface rowReturn {
  id: string
  supplierName: string
  taskId: string
  proxy: boolean
}
const buttonTypeMap = ref('')
// 点击删除或者取消
const handleDelete = (row: rowReturn) => {
  ElMessageBox.confirm(
    '确认删除所选记录吗？',
    '提示',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  ).then(() => {
    getApprovalDelete({ id: row.id, taskId: row.taskId }).then((res) => {
      if (res.code === 200) {
        ElMessage({
          type: 'success',
          message: '删除成功',
        })
        fetchData(true)
      }
    })
  })
}

// 取消
const handleCancel = (row: ISupplier) => {
  const params = {
    taskId: row.taskId!,
    comments: '',
  }
  ElMessageBox.confirm(
    '确认取消该审批吗？',
    '提示',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  )
    .then(() => {
      submitApproval('revoke', params).then((res) => {
        ElMessage({
          type: 'success',
          message: '取消成功',
        })
        fetchData(true)
      })
    })
}

const approvalDialog = ref()

// 点击搜索
const searchList = () => {
  fetchData(false)
}
const cancelEvent = () => {
  console.log('cancel!')
}
// 点击重置
const clearList = () => {
  listQuery.value = {
    approvalStatus: props.status,
    formId: SCHEDULE.TRAIN_APPROVAL,
    createTime: '',
    deptId: '',
    director: '',
    effectiveCompany: '',
    trainTime: '',
    offset: 1,
    limit: 20,
  }
  fetchData(true)
}
// 主管部门下拉框
const options = ref<IOptions[]>([])
// 导出类型
interface supplierExportQuery {
  approvalStatus: string
  businessContent: string
  companyArea: string
  companyCity: string
  companyProvince: string
  effectiveCompany: string
  formId: string
  supplierName: string
  supplierNo: string
}

// 导出
const exportExcelBtn = () => {
  const params: supplierExportQuery = {
    approvalStatus: listQuery.value.approvalStatus,
    businessContent: listQuery.value.businessContent,
    companyArea: listQuery.value.companyArea,
    companyCity: listQuery.value.companyCity,
    companyProvince: listQuery.value.companyProvince,
    formId: listQuery.value.formId,
    supplierName: listQuery.value.supplierName,
    supplierNo: listQuery.value.supplierNo,
  }
  if (checkoutList.value.length > 0) {
    params.ids = checkoutList.value
  }
  // TODO: 审批列表导出
  console.log(params)
  const loading = ElLoading.service({
    lock: true,
    text: 'Loading',
    background: 'rgba(255, 255, 255, 0.8)',
  })
  loading.close()
}

// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  fetchData(true)
}
// 跳转到详情
const goDetail = (row: ISupplier) => {
  $router.push(`trainPlanApprove/${props.status}/${row.id}`)
}
// 获取到组织信息
const getDept = () => {
  const params = {
    roleId: '',
    deptType: '',
    tips: '',
  }
  getDeptTree(params).then((response) => {
    options.value = response.data
  })
}
getDept()
// 提交
const approvalSubmit = (row: ISupplier) => {
  ElMessageBox.confirm('确认提交吗？', '提示', {
    confirmButtonText: '确认',
    cancelButtonText: '取消',
    type: 'warning',
  }).then(() => {
    getListSubmit({ id: row.id, formId: SCHEDULE.TRAIN_APPROVAL }).then((res) => {
      if (res.code === 200) {
        ElMessage({
          type: 'success',
          message: '提交成功',
        })
        fetchData(true)
      }
    })
  })
}
// 批量导出
const exportAll = () => {
  exportExcelBtn()
}
// 审批结束回调
const approvalSuccess = () => {
  fetchData(true)
}
// 审批弹窗关闭
const handleClose = () => {
  applyShow.value = false
}

// 点击数据后的操作按钮
const clickBtn = (row: ISupplier, buttonType: string) => {
  switch (buttonType) {
    case '查看':
      goDetail(row)
      break
    case '提交':
      approvalSubmit(row)
      break
    case '编辑':
      $router.push(`/train/edit/${row.id}`)
      break
    case '同意':
      approvalDialog.value.initDialog('agree', row.taskId)
      break
    case '驳回':
      approvalDialog.value.initDialog('reject', row.taskId)
      break
    case '拒绝':
      approvalDialog.value.initDialog('refuse', row.taskId)
      break
    case '取消':
      handleCancel(row)
      break
    case '删除':
      handleDelete(row)
      break
  }
}

// 监听status变化，更新approvalStatus
watch (
  () => props.status,
  (newVal: string) => {
    listQuery.value.approvalStatus = newVal
    fetchData(false)
  },
  { immediate: true })
// 打印列表
function printList() {
  // 打印列
  const properties = columns.value.map((item) => {
    return {
      field: item.value,
      displayName: item.text,
    }
  })
  if (checkoutList.value.length <= 0 && list.value.length > 0) {
    printJSON(list.value, properties, '培训计划审批列表')
  }
  else if (checkoutList.value.length > 0) {
    const printList = list.value.filter((item: ISupplier) => checkoutList.value.includes(item.id))
    printJSON(printList, properties, '培训计划审批列表')
  }
  else {
    ElMessage.warning('无可打印内容')
  }
}
</script>

<template>
  <app-container>
    <search-area
      :need-clear="true"
      @search="searchList" @clear="clearList"
    >
      <search-item>
        <el-date-picker
          v-model="listQuery.trainTime"
          type="datetime"
          placeholder="培训时间"
          format="YYYY/MM/DD HH:mm:ss"
          value-format="YYYY-MM-DD h:m:s"
          :disabled="buttonType === '详情'"
        />
      </search-item>
      <search-item>
        <el-date-picker
          v-model="listQuery.createTime"
          type="datetime"
          placeholder="创建时间"
          format="YYYY/MM/DD HH:mm:ss"
          value-format="YYYY-MM-DD h:m:s"
          :disabled="buttonType === '详情'"
        />
      </search-item>
      <search-item>
        <el-select
          v-model="listQuery.deptId"
          clearable
          placeholder="主管部门"
          size="default"
        >
          <el-option
            v-for="item in options"
            :key="item.id"
            :label="item.name"
            :value="item.id"
          />
        </el-select>
      </search-item>
      <search-item>
        <el-input
          v-model.trim="listQuery.effectiveCompany"
          placeholder="实施单位"
          clearable
        />
      </search-item>
      <search-item>
        <el-input
          v-model.trim="listQuery.director"
          placeholder="负责人"
          clearable
        />
      </search-item>
    </search-area>
    <table-container>
      <template #btns-right>
        <icon-button v-if="proxy.hasPerm('/train/plan/approve/export')" icon="icon-export" title="导出" type="primary" @click="exportAll" />
        <icon-button v-if="proxy.hasPerm('/train/plan/approve/print')" icon="icon-print" title="打印" type="primary" @click="printList" />
      </template>
      <normal-table
        :data="list" :total="total" :columns="columns" :query="listQuery"
        :list-loading="loadingTable" is-showmulti-select @change="changePage" @multiSelect="handleSelectionChange"
      >
        <template #columns>
          <el-table-column label="操作" align="center" :width="operationWidth">
            <template #default="{ row }">
              <el-button
                size="small"
                type="primary"
                link
                @click="clickBtn(row, '查看')"
              >
                查看
              </el-button>
              <el-button
                v-if="proxy.hasPerm('/train/plan/approve/agree') && (status === '0' || status === '2')"
                size="small"
                link
                type="primary"
                :disabled="row.approvalStatusName !== '待审批' && row.approvalStatusName !== '审批中'"
                @click="clickBtn(row, '同意')"
              >
                同意
              </el-button>
              <el-button
                v-if="proxy.hasPerm('/train/plan/approve/regect') && (status === '0' || status === '2')"
                size="small"
                link
                type="primary"
                :disabled="row.approvalStatusName !== '待审批' && row.approvalStatusName !== '审批中'"
                @click="clickBtn(row, '驳回')"
              >
                驳回
              </el-button>
              <el-button
                v-if="proxy.hasPerm('/train/plan/approve/refuse') && (status === '0' || status === '2')"
                size="small"
                link
                type="danger"
                :disabled="row.approvalStatusName !== '待审批' && row.approvalStatusName !== '审批中'"
                @click="clickBtn(row, '拒绝')"
              >
                拒绝
              </el-button>
              <el-button
                v-if="proxy.hasPerm('/train/plan/approve/edit') && (status === '1' || status === '6')"
                size="small"
                link
                type="primary"
                @click="clickBtn(row, '编辑')"
              >
                编辑
              </el-button>
              <el-button
                v-if="status === '1' || status === '6'"
                size="small"
                link
                type="primary"
                @click="clickBtn(row, '提交')"
              >
                提交
              </el-button>
              <!-- 是发起者且审批中可以取消 -->
              <el-button
                v-if="proxy.hasPerm('/train/plan/approve/cancel') && (status === '0' || status === '3')"
                size="small"
                link
                type="info"
                :disabled="row.approvalStatusName !== '审批中'"
                @click="clickBtn(row, '取消')"
              >
                取消
              </el-button>
              <!-- 发起者和有删除权限的可以删除，已通过未通过状态不可以删除 -->
              <el-button
                v-if="proxy.hasPerm('/train/plan/approve/delete') && (status !== '4' && status !== '5')"
                size="small"
                link
                type="danger"
                :disabled="row.approvalStatusName === '未通过' || row.approvalStatusName === '已通过'"
                @click="clickBtn(row, '删除')"
              >
                删除
              </el-button>
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </table-container>
  </app-container>
  <approval-dialog ref="approvalDialog" @on-success="approvalSuccess" />
</template>

